<template>
  <q-item
    v-if="hasControls"
    clickable
    @click="onClickSettingsDialog"
    class="text-grey-7 display-settings-list-item"
  >
    <q-item-section
      thumbnail
      class="q-pl-md"
    >
      <q-icon
        name="las la-cogs"
        size="sm"
      />
    </q-item-section>

    <q-item-section
      v-if="showPKDisplayControl"
      class="q-pl-sm"
    >
      <q-item-label
        v-if="showPKDisplayControl"
        caption
        lines="1"
      >
        <translate v-if="displayPKAsOxyde">
          P and K as oxydes
        </translate>
        <translate v-else>
          P and K as elements
        </translate>
      </q-item-label>

      <q-item-label
        v-if="showBeforeAfterFertilizationControl"
        caption
        lines="1"
      >
        <translate v-if="includePlannedFertilization">
          Including the planned fertilization
        </translate>
        <translate v-else>
          Without the planned fertilization
        </translate>
      </q-item-label>
    </q-item-section>
  </q-item>
</template>

<script>
import algorithms from 'src/services/fieldbook/fertilization/algorithms'
import FertilizationResultDisplaySettingsDialog from 'src/pages/fieldbook/fertilization/algorithms/common/components/FertilizationResultDisplaySettingsDialog'

export default {
  name: 'FertilizationPlanDisplaySettingsListItem',
  props: {
    fertilizationPlans: {
      type: Array,
      default: null
    },
    hideDisplayPKAsOxydeControl: {
      type: Boolean,
      default: false
    },
    hideResultAfterFertilizationControl: {
      type: Boolean,
      default: false
    }
  },
  data () {
    return {
      showDialog: false,
      showResultAfterFertilization: false
    }
  },
  computed: {
    hasControls () {
      return this.showPKDisplayControl || this.showBeforeAfterFertilizationControl
    },
    showPKDisplayControl () {
      return !this.hideDisplayPKAsOxydeControl && this.checkControlSupport('pkDisplay')
    },
    showBeforeAfterFertilizationControl () {
      return !this.hideResultAfterFertilizationControl && this.checkControlSupport('beforeAfterFertilization')
    },
    displayPKAsOxyde () {
      return this.$store.state.appState.displayPKAsOxyde
    },
    includePlannedFertilization () {
      return this.$store.state.appState.includePlannedFertilization
    }
  },
  methods: {
    checkControlSupport (controlName) {
      if (!this.fertilizationPlans?.length) {
        return false
      } else {
        const algoConfigs = new Set(this.fertilizationPlans
          .map(plan => algorithms[plan.algorithm.id])
          .filter(algoConfig => Boolean(algoConfig))
        )
        const algosWithSupport = [...algoConfigs].filter(algoConfig => algoConfig.controls?.[controlName])
        return algosWithSupport.length > 0
      }
    },
    onClickSettingsDialog () {
      this.$q.dialog({
        component: FertilizationResultDisplaySettingsDialog,
        componentProps: {
          showPKDisplayControl: this.showPKDisplayControl,
          showBeforeAfterFertilizationControl: this.showBeforeAfterFertilizationControl
        }
      })
    }
  }
}
</script>

<style scoped>
.display-settings-list-item {
  min-height: auto;
  padding-top: 4px;
  padding-bottom: 4px;
}
</style>
